using Mox.Shared.Math;

namespace Mox.Shared.Renderer
{
	public abstract class ImageBase
	{
		public abstract int Width
		{
			get;
		}

		public abstract int Height
		{
			get;
		}
	}

	public class SubImage
	{
		public SubImage(ImageBase _image)
		{
			Image = _image;
		}

		public Rect Rect
		{
			get
			{
				return m_RectOverride ?? new Rect(0, 0, Image.Width, Image.Height);
			}
			set
			{
				m_RectOverride = value;
			}
		}

		private Rect m_RectOverride;
		public readonly ImageBase Image;
	}
}
